HTTP::Cookies - Crystal 0.35.1

# class HTTP::Cookies

- HTTP::Cookies
- Reference
- Object

##
Overview

Represents a collection of cookies as it can be present inside a HTTP request or response.

##
Included Modules

- Enumerable(HTTP::Cookie)

##
Defined in:

##
Constructors

- .from_headers(headers) : self

  Creates a new instance by parsing the `Cookie` and `Set-Cookie` headers in the given `HTTP::Headers`.

- .new

  Creates a new empty instance.

##
Instance Method Summary

- #<<(cookie : Cookie)

  Adds the given cookie to this collection, overrides an existing cookie with the same name if present.

- #[](key)

  Gets the current `HTTP::Cookie` for the given key.

- #[]=(key, value : String)

  Sets a new cookie in the collection with a string value.

- #[]=(key, value : Cookie)

  Sets a new cookie in the collection to the given `HTTP::Cookie` instance.

- #[]?(key)

  Gets the current `HTTP::Cookie` for the given key or `nil` if none is set.

- #add_request_headers(headers)

  Adds `Cookie` headers for the cookies in this collection to the given `HTTP::Headers` instance and returns it.

- #add_response_headers(headers)

  Adds `Set-Cookie` headers for the cookies in this collection to the given `HTTP::Headers` instance and returns it.

- #clear

  Clears the collection, removing all cookies.

- #delete(key)

  Deletes and returns the `HTTP::Cookie` for the specified key, or returns `nil` if key cannot be found in the collection.

- #each(&block : Cookie -> )

  Yields each `HTTP::Cookie` in the collection.

- #each

  Returns an iterator over the cookies of this collection.

- #empty?

  Whether the collection contains any cookies.

- #fill_from_headers(headers)

  Filling cookies by parsing the `Cookie` and `Set-Cookie` headers in the given `HTTP::Headers`.

- #has_key?(key)

  Returns `true` if a cookie with the given key exists.

- #size

  Returns the number of cookies contained in this collection.

- #to_h

  Returns this collection as a plain `Hash`.

### Instance methods inherited from module `Enumerable(HTTP::Cookie)`

all?(&)
all?(pattern)
all? all?, any?(&)
any?(pattern)
any? any?, chunks(&block : T -> U) forall U chunks, compact_map(&) compact_map, count(&)
count(item) count, cycle(&)
cycle(n, &) cycle, each(&block : T -> _) each, each_cons(count : Int, reuse = false, &) each_cons, each_cons_pair(& : T, T -> _) : Nil each_cons_pair, each_slice(count : Int, reuse = false, &) each_slice, each_with_index(offset = 0, &) each_with_index, each_with_object(obj, &) each_with_object, empty? empty?, find(if_none = nil, &) find, first(&)
first(count : Int)
first first, first? first?, flat_map(&block : T -> Array(U) | Iterator(U) | U) forall U flat_map, grep(pattern) grep, group_by(&block : T -> U) forall U group_by, in_groups_of(size : Int, filled_up_with : U = nil) forall U
in_groups_of(size : Int, filled_up_with : U = nil, reuse = false, &) forall U in_groups_of, includes?(obj) includes?, index(&)
index(obj) index, index_by(&block : T -> U) forall U index_by, join(separator = "", & : T -> )
join(separator, io : IO, &)
join(io : IO, separator = "", & : T, IO -> )
join(separator = "")
join(separator, io : IO)
join(io : IO, separator = "") join, map(&block : T -> U) forall U map, map_with_index(offset = 0, &block : T, Int32 -> U) forall U map_with_index, max max, max? max?, max_by(&block : T -> U) forall U max_by, max_by?(&block : T -> U) forall U max_by?, max_of(&block : T -> U) forall U max_of, max_of?(&block : T -> U) forall U max_of?, min min, min? min?, min_by(&block : T -> U) forall U min_by, min_by?(&block : T -> U) forall U min_by?, min_of(&block : T -> U) forall U min_of, min_of?(&block : T -> U) forall U min_of?, minmax minmax, minmax? minmax?, minmax_by(&block : T -> U) forall U minmax_by, minmax_by?(&block : T -> U) forall U minmax_by?, minmax_of(&block : T -> U) forall U minmax_of, minmax_of?(&block : T -> U) forall U minmax_of?, none?
none?(pattern)
none?(&) none?, one?(&)
one?(pattern)
one? one?, partition(&) partition, product
product(initial : Number)
product(initial : Number, &)
product(&) product, reduce(memo, &)
reduce(&) reduce, reduce?(&) reduce?, reject(pattern)
reject(type : U.class) forall U
reject(&block : T -> ) reject, select(pattern)
select(type : U.class) forall U
select(&block : T -> ) select, size size, skip(count : Int) skip, skip_while(&) skip_while, sum(initial)
sum
sum(initial, &)
sum(&) sum, take_while(&) take_while, tally : Hash(T, Int32) tally, to_a to_a, to_h
to_h(&block : T -> Tuple(K, V)) forall K, V to_h, to_set to_set, zip(*others : Indexable | Iterable | Iterator, &)
zip(*others : Indexable | Iterable | Iterator) zip, zip?(*others : Indexable | Iterable | Iterator, &)
zip?(*others : Indexable | Iterable | Iterator) zip?

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference)
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(*values : Object) : Bool
in?(collection) : Bool in?, inspect : String
inspect(io : IO) : Nil inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO)
to_json to_json, to_pretty_json(io : IO, indent : String = " ")
to_pretty_json(indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

##
Constructor Detail

def self.from_headers(headers) : self #

Creates a new instance by parsing the `Cookie` and `Set-Cookie` headers in the given `HTTP::Headers`.

See `HTTP::Request#cookies` and `HTTP::Client::Response#cookies`.

def self.new #

Creates a new empty instance.

##
Instance Method Detail

def <<(cookie : Cookie) #

Adds the given cookie to this collection, overrides an existing cookie with the same name if present.

    response.cookies << HTTP::Cookie.new("foo", "bar", http_only: true)

def [](key) #

Gets the current `HTTP::Cookie` for the given key.

    request.cookies["foo"].value # => "bar"

def []=(key, value : String) #

Sets a new cookie in the collection with a string value. This creates a never expiring, insecure, not HTTP only cookie with no explicit domain restriction and the path `/`.

    require "http/client"

    request = HTTP::Request.new "GET", "/"
    request.cookies["foo"] = "bar"

def []=(key, value : Cookie) #

Sets a new cookie in the collection to the given `HTTP::Cookie` instance. The name attribute must match the given key, else `ArgumentError` is raised.

    require "http/client"

    response = HTTP::Client::Response.new(200)
    response.cookies["foo"] = HTTP::Cookie.new("foo", "bar", "/admin", Time.utc + 12.hours, secure: true)

def []?(key) #

Gets the current `HTTP::Cookie` for the given key or `nil` if none is set.

    require "http/client"

    request = HTTP::Request.new "GET", "/"
    request.cookies["foo"]? # => nil
    request.cookies["foo"] = "bar"
    request.cookies["foo"]?.try &.value # > "bar"

def add_request_headers(headers) #

Adds `Cookie` headers for the cookies in this collection to the given `HTTP::Headers` instance and returns it. Removes any existing `Cookie` headers in it.

def add_response_headers(headers) #

Adds `Set-Cookie` headers for the cookies in this collection to the given `HTTP::Headers` instance and returns it. Removes any existing `Set-Cookie` headers in it.

def clear #

Clears the collection, removing all cookies.

def delete(key) #

Deletes and returns the `HTTP::Cookie` for the specified key, or returns `nil` if key cannot be found in the collection. Note that key should match the name attribute of the desired `HTTP::Cookie`.

def each(&block : Cookie -> ) #

Yields each `HTTP::Cookie` in the collection.

def each #

Returns an iterator over the cookies of this collection.

def empty? #

Whether the collection contains any cookies.

def fill_from_headers(headers) #

Filling cookies by parsing the `Cookie` and `Set-Cookie` headers in the given `HTTP::Headers`.

def has_key?(key) #

Returns `true` if a cookie with the given key exists.

    request.cookies.has_key?("foo") # => true

def size #

Returns the number of cookies contained in this collection.

def to_h #

Returns this collection as a plain `Hash`.